package jp.gr.java_conf.matsubara.expresser.type;

import java.util.ArrayList;
import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.Variable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.property.String__charAt;
import jp.gr.java_conf.matsubara.expresser.type.property.String__charCodeAt;
import jp.gr.java_conf.matsubara.expresser.type.property.String__concat;
import jp.gr.java_conf.matsubara.expresser.type.property.String__indexOf;
import jp.gr.java_conf.matsubara.expresser.type.property.String__lastIndexOf;
import jp.gr.java_conf.matsubara.expresser.type.property.String__localeCompare;
import jp.gr.java_conf.matsubara.expresser.type.property.String__match;
import jp.gr.java_conf.matsubara.expresser.type.property.String__replace;
import jp.gr.java_conf.matsubara.expresser.type.property.String__search;
import jp.gr.java_conf.matsubara.expresser.type.property.String__slice;
import jp.gr.java_conf.matsubara.expresser.type.property.String__split;
import jp.gr.java_conf.matsubara.expresser.type.property.String__substring;
import jp.gr.java_conf.matsubara.expresser.type.property.String__toChar;
import jp.gr.java_conf.matsubara.expresser.type.property.String__toCharArray;
import jp.gr.java_conf.matsubara.expresser.type.property.String__toLowerCase;
import jp.gr.java_conf.matsubara.expresser.type.property.String__toUpperCase;


/**
 * v~eBu^̕^łB<br/>
 * <br/>
 * 쐬: 2005/02/06
 * 
 * @author m.matsubara
 *
 */
public class _String implements IExpObject {
    private static ExpObject prototype = null;
    
    public int propertyId$length = StringToId.toId("length").intValue();

    private String value;
    private int hashCode;
    
    public _String(Object o) throws ExpException {
        if (o != null)  
            this.value = o.toString();
        else
            this.value = "";
        hashCode = this.value.hashCode();
        
        getPrototype();
    }
    
    public boolean equals(Object object) {
        if (this == object)
            return true;
        else if (object instanceof _String)
            return value.equals(((_String)object).value);
        else
            return value.equals(object);
    }
    
    public int length() {
        return value.length();
    }
    
    public String toString() {
        return value;
    }
    
    public int hashCode() {
        return hashCode;
    }
    
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#deleteProperty(java.lang.Integer)
     */
    public IExpObject deleteProperty(Integer id) throws ExpException {
        return new _Boolean(true);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        int idValue = id.intValue();
        if (idValue == propertyId$length)
            return new _Integer(value.length());
        else {
            return prototype.getProperty(id);
        }
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(java.lang.Integer, java.lang.Object)
     */
    public void putProperty(Integer id, IExpObject value) throws ExpException {

    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(int)
     */
    public IExpObject getProperty(int index) throws ExpException {
        return Expresser.UNDEFINED;
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(int, java.lang.Integer)
     */
    public void putProperty(int index, IExpObject value) throws ExpException {
        // Ȃ
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(java.lang.Integer)
     */
    public IVariable getVariable(Integer id) {
        return new ExpObjectMember(this, id);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(int)
     */
    public IVariable getVariable(int index) {
        return new Variable(Expresser.UNDEFINED);  //   ANZXĂG[ɂȂȂAl͏undefinedƂȂ  
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#isProperty(java.lang.Integer, boolean)
     */
    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        if (searchPrototype)
            return prototype.isProperty(id, searchPrototype);
        else
            return false;
    }
    
    /*
     *  ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getConstructorList()
     */
    public List getConstructorList() {
        return new ArrayList(0);
    }

    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#enumProperty()
     */
    public Integer[] enumProperty() {
        return new Integer[0];
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static synchronized ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
            prototype.putProperty(String__charAt.ID,        String__charAt.getInstance());
            prototype.putProperty(String__charCodeAt.ID,    String__charCodeAt.getInstance());
            prototype.putProperty(String__concat.ID,        String__concat.getInstance());
            prototype.putProperty(String__indexOf.ID,       String__indexOf.getInstance());
            prototype.putProperty(String__lastIndexOf.ID,   String__lastIndexOf.getInstance());
            prototype.putProperty(String__localeCompare.ID, String__localeCompare.getInstance());
            prototype.putProperty(String__toLowerCase.ID,   String__toLowerCase.getInstance());
            prototype.putProperty(String__toLowerCase.toLocaleLowerCaseID,   String__toLowerCase.getInstance());
            prototype.putProperty(String__toUpperCase.ID,   String__toUpperCase.getInstance());
            prototype.putProperty(String__toUpperCase.toLocaleUpperCaseID,   String__toUpperCase.getInstance());
            prototype.putProperty(String__match.ID,         String__match.getInstance());
            prototype.putProperty(String__search.ID,        String__search.getInstance());
            prototype.putProperty(String__replace.ID,       String__replace.getInstance());
            prototype.putProperty(String__slice.ID,         String__slice.getInstance());
            prototype.putProperty(String__split.ID,         String__split.getInstance());
            prototype.putProperty(String__substring.ID,     String__substring.getInstance());

            prototype.putProperty(String__toChar.ID,        String__toChar.getInstance());
            prototype.putProperty(String__toCharArray.ID,   String__toCharArray.getInstance());
        }
        return prototype;
    }
}
