package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * Array^ join() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__join extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("join");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__join() throws ExpException {
        super("join", 2);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        String separater = ",";
        if (arguments.length >= 1)
            separater = arguments[0].toString();
            
        StringBuffer sb = new StringBuffer();
        Object obj;
        int max = value.length();
        if (max != 0) {
            obj = value.getProperty(0);
            if (obj != Expresser.UNDEFINED)
                sb.append(obj);
            for (int idx = 1; idx < max; idx++) {
                sb.append(separater);
                obj = value.getProperty(idx);
                if (obj != Expresser.UNDEFINED) {
                    sb.append(obj);
                }
            }
        }
        return new _String(sb.toString());
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__join();
        return instance;
    }
}
