package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;


/**
 * Array^ shift() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/10
 * 
 * @author m.matsubara
 */

public class Array__shift extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("shift");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__shift() throws ExpException {
        super("shift", 0);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray array = (IArray)thisObject;
        int length = array.length();
        if (length == 0)
            return Expresser.UNDEFINED;
        
        IExpObject result = array.getProperty(0);
        
        
        for (int idx = 0; idx < length - 1; idx++) {
            IExpObject value = array.getProperty(idx + 1);
            array.putProperty(idx, value);
        }
        array.setLength(length - 1);
        return result;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__shift();
        return instance;
    }
}
