package jp.gr.java_conf.matsubara.regexp;


/**
 * K\RANX𐶐t@NgłB<br/>
 * <br/>
 * 쐬: 2005/08/06
 * 
 * @author m.matsubara
 */
public class RegExpCoreFactory {
    private static Class regExpCoreClass = null;
    private static Object mutex = new Object();
    
    /**
     * K\RANX𐶐
     * @return
     * @throws Exception
     */
    public static IRegExpCore create() throws Exception {
        IRegExpCore regExpCore = null;
        //  K\RANẌꗗ
        String[] regExpCoreClassNames = { 
                "jp.gr.java_conf.matsubara.regexp.ORORegExpCore", 
                "jp.gr.java_conf.matsubara.regexp.JavaRegExpCore",
        };
        
        //  p\ȐK\RANX肳ĂȂ肷
        if (regExpCoreClass == null) {
            synchronized (mutex) {
                int max = regExpCoreClassNames.length;
                for (int idx = 0; idx < max; idx++) {
                    try {
                        regExpCoreClass = Class.forName(regExpCoreClassNames[idx]);
                        //  CX^X̐
                        regExpCore = (IRegExpCore)(regExpCoreClass.newInstance());
                        return regExpCore;
                    } catch (Throwable t) {
                        //  NXȂEP[WG[E̎sȂ
                        //  ̐K\RANXB
                    }
                }
                if (regExpCoreClass == null)
                    throw new Exception("RegExp class create failure.");
            }
        }
        
        //  CX^X̐
        regExpCore = (IRegExpCore)(regExpCoreClass.newInstance());
        return regExpCore;
    }
}
