package jp.gr.java_conf.matsubara.expresser.scope;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;

/**
 * ϐANZX̍ۂ̃XR[v`܂B<br/>
 * <br/>
 * 쐬: 2005/06/04
 * 
 * @author m.matsubara
 */
public interface IScope {
    /**
     * ϐIuWFNg擾܂B
     * @param id ϐID
     * @return ϐIuWFNg
     */
    public IVariable getVariable(Integer id) throws ExpException;
    
    /**
     * ϐIuWFNg擾܂B
     * @param id ϐID
     * @param offset ϐ֍ɃANZX邽߂̃p[^
     * @return ϐIuWFNg
     */
    public IVariable getVariable(Integer id, int offset) throws ExpException;

    /**
     * ϐ̒lԂ܂B
     * @param id ϐID
     * @return ϐ̒l
     */
    public IExpObject getValue(Integer id) throws ExpException;

    /**
     * ϐ̒lԂ܂B
     * @param id ϐID
     * @param offset ϐ֍ɃANZX邽߂̃p[^
     * @return ϐ̒l
     */
    public IExpObject getValue(Integer id, int offset) throws ExpException;

    /**
     * ϐ̒lݒ肵܂B
     * @param id ϐID
     * @param value l
     */
    public void setValue(Integer id, IExpObject value) throws ExpException;
    
    /**
     * ϐ̒lݒ肵܂B
     * @param id ϐID
     * @param offset ϐ֍ɃANZX邽߂̃p[^
     * @param value l
     */
    public void setValue(Integer id, int offset, IExpObject value) throws ExpException;
    
    /**
     * IDŎVϐ쐬o^܂B
     * @param id ϐID
     * @return o^ꂽϐ
     */
    public IVariable defineVariable(Integer id) throws ExpException; 

    /**
     * gŉłȂXR[v̕ϐ̂߂̃XR[v`FCݒ肵܂B<br/>
     * eXR[vݒ肵܂B<br/>
     * @param nextScope eXR[v
     */
    public void setScopeChain(IScope nextScope);

    /**
     * gŉłȂXR[v̕ϐ̂߂̃XR[v`FC擾܂B
     * @return nextScope eXR[v
     */
    public IScope getScopeChain();
    
    /**
     * ϐɍɃANZX邽߂̃ItZbgl擾܂B<br/>
     * ϐɍɃANZX邽߂̃ItZbglT|[gȂXR[v0Ԃ܂B<br/>
     * @param id ϐID
     * @return ϐɍɃANZX邽߂̃ItZbgl
     */
    public int getOffset(Integer id);
}
